package dev.shadowsoffire.apotheosis.adventure.gen;

import com.mojang.datafixers.kinds.Applicative;
import java.util.function.Function;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.world.level.levelgen.feature.configurations.FeatureConfiguration;
import net.minecraft.world.level.levelgen.structure.templatesystem.TagMatchTest;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.util.RandomSource;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.WorldGenLevel;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.apotheosis.adventure.spawner.RogueSpawnerRegistry;
import dev.shadowsoffire.apotheosis.adventure.spawner.RogueSpawner;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import net.minecraft.world.level.levelgen.feature.FeaturePlaceContext;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.structure.templatesystem.RuleTest;
import net.minecraft.world.level.levelgen.feature.Feature;

public class RogueSpawnerFeature extends Feature<Config>
{
    public static final RuleTest STONE_TEST;
    
    public RogueSpawnerFeature() {
        super((Codec)Config.CODEC);
    }
    
    public boolean m_142674_(final FeaturePlaceContext<Config> ctx) {
        final WorldGenLevel world = ctx.m_159774_();
        if (!AdventureConfig.canGenerateIn(world)) {
            return false;
        }
        final BlockPos pos = ctx.m_159777_();
        final RandomSource rand = ctx.m_225041_();
        if (rand.m_188501_() <= ((Config)ctx.m_159778_()).successChance()) {
            final BlockState state = world.m_8055_(pos);
            final BlockState downState = world.m_8055_(pos.m_7495_());
            final BlockState upState = world.m_8055_(pos.m_7494_());
            if (RogueSpawnerFeature.STONE_TEST.m_213865_(downState, rand) && upState.m_60795_() && (state.m_60795_() || RogueSpawnerFeature.STONE_TEST.m_213865_(state, rand))) {
                final RogueSpawner item = (RogueSpawner)RogueSpawnerRegistry.INSTANCE.getRandomItem(rand);
                if (item == null) {
                    return false;
                }
                item.place(world, pos, rand);
                AdventureModule.debugLog(pos, "Rogue Spawner - " + RogueSpawnerRegistry.INSTANCE.getKey((CodecProvider)item));
                return true;
            }
        }
        return false;
    }
    
    static {
        STONE_TEST = (RuleTest)new TagMatchTest(BlockTags.f_13061_);
    }
    
    record Config(float successChance) implements FeatureConfiguration {
        public static final Codec<Config> CODEC;
        
        static {
            CODEC = RecordCodecBuilder.create(inst -> inst.group((App)Codec.floatRange(0.0f, 1.0f).fieldOf("success_chance").forGetter((Function)Config::successChance)).apply((Applicative)inst, (Function)Config::new));
        }
    }
}
